%
% Finding a 3-coloring of a graph (if any exists)

edge(0,1).
edge(1,2).
edge(2,0).
edge(1,3).
edge(2,3).

col(red).
col(blue).
col(green).

graph_coloring(G,L):- gr_col(G,[],L).

gr_col([],L,L):-!.
gr_col([N|R],P,L):- vertex_color(N,C,P), gr_col(R, [color(N,C)|P],L).

vertex_color(N,C,P):- col(C), ok_color(N,C,P).

neighbourhood(N,B,L):- (edge(N,N1);edge(N1,N)),  
                     \+ member(N1,B), !,
                     neighbourhood(N,[N1|B],L).
neighbourhood(_,L,L).

ok_color(N,C,P):- neighbourhood(N,[],L), check_color(L,C,P).

check_color([],_,_):-!.
check_color([N1|B],C,P):- \+ member(color(N1,C),P),!, 
                          check_color(B,C,P).

member(E, [E|X]):- !.
member(E, [_|X]):- member(E,X).
