%
% Family trees
% (transitive closure)

grandparent(V,W):- grandfather(V,W).
grandparent(Z,K):- grandmother(Z,K).

grandfather(X,Y):-father(X,Z),father(Z,Y).
grandfather(X,Y):-father(X,Z), mother(Z,Y).
%
grandmother(X,Y):-mother(X,Z),father(Z,Y).
grandmother(X,Y):-mother(X,Z), mother(Z,Y).
%
father(giovanni,cristina).
mother(patrizia,cristina).
mother(cristina,beatrice).
mother(beatrice,annalisa).
mother(beatrice,giacomo).
%
parent(X,Y):-mother(X,Y).
parent(X,Y):-father(X,Y).
%
ancestor(V,W):-parent(V,W).
ancestor(V,W):-parent(V,Z),ancestor(Z,W).
