%
% A complete metainterpreter 
% that manages auxiliary inference rules 
% defining forms of equivalence

% Properties of predicates (meta-level)
traduzione(happy,felice).
traduzione(friend,amico).
traduzione(mother,mamma).

sinonimo(allegro,felice).
sinonimo(amico,sodale).

% Object-level facts
felice(anna).
felice(mario).
allegro(gianni).
amico(mario,carlo).
amico(anna,giorgio).
mamma(giorgia,beatrice).
mamma(beatrice,giacomo).
mamma(beatrice,giorgio).
happy(george).
%mother(anne,carl).
friend(anne,mary).

% meta-level
equivalente(P,P1):-trad(P,P1).
equivalente(P,P1):-sin(P1,P).
equivalente(P,P1):-sintrad(P1,P).

trad(P,Q):-traduzione(P,Q).
trad(P,Q):-traduzione(Q,P).
sin(P,Q):-sinonimo(P,Q).
sin(P,Q):-sinonimo(Q,P).
sintrad(P,Q):- trad(P,P1),sin(P1,Q).
sintrad(P,Q):- sin(P,P1),trad(P1,Q).


demo(true):-!.
demo(G):- \+ G = (_,_),
	  clause(G,Body), demo(Body).
demo((G1,G2)) :- demo(G1), demo(G2).

demo(G):- G =.. [F|L], equivalente(F,F1), 
          G1 =..[F1|L],clause(G1,T),demo(G1).
demo(G):- G =.. [F|L], \+ equivalente(F,F1), 
	write('non ho capito rifai la domanda').