%
% Finding acyclic paths on graphs with cycles


edge(a,b).
edge(b,c).
edge(c,e).
edge(c,d).
edge(d,f).
edge(c,f).
edge(a,f).
edge(f,g).
edge(g,a).
edge(g,h).

%path(X,Y):- edge(X,Y).
%path(X,Y):- edge(X,Z),path(Z,Y).

reduce([X|T], X, T).
reduce([H|T], X, [H|L]) :- reduce(T, X, L).

path(X, X, L, []).
path(X, Y, L, [X,Y]):- edge(X, Y),!,
		member(Y,L).
path(X, Y, L, [X|C]) :-
		edge(X, Z),
		member(Z,L),
		reduce(L, Z, L1),
		path(Z, Y, L1, C).


yes1(C):- path(a, b, [a, b, c, d, e, f, g, h],C).

yes2(C):- path(a, h, [a, b, c, d, e, f, g, h],C).


